/**
  * File: DynamicSubgroupsUserBaseImpl.java
  * Content: Defines an abstract corba class to implement the DynamicSubgroupsUser interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the DomainGroupUser CORBA interface.
  **/
public abstract class DynamicSubgroupsUserBaseImpl extends DynamicSubgroupsUserPOA {

	public DynamicSubgroupsUserBaseImpl() throws UserException {
		this(true);
	}

	public DynamicSubgroupsUserBaseImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisDynamicSubgroupsUser == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisDynamicSubgroupsUser = DynamicSubgroupsUserHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisDynamicSubgroupsUser != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisDynamicSubgroupsUser = null;
		}
	}

	public final DynamicSubgroupsUser theDynamicSubgroupsUser() {
		return thisDynamicSubgroupsUser;
	}

	protected DynamicSubgroupsUser thisDynamicSubgroupsUser;
	byte[] id;
};
