/**
  * File: ExtendedCheckpointableBaseImpl.java
  * Content: Defines an abstract corba class to implement the ExtendedCheckpointable interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the ExtendedCheckpointable CORBA interface.
  **/
public abstract class ExtendedCheckpointableBaseImpl extends ExtendedCheckpointablePOA {

	public ExtendedCheckpointableBaseImpl() throws UserException {
		this(true);
	}

	public ExtendedCheckpointableBaseImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisExtendedCheckpointable == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisExtendedCheckpointable = ExtendedCheckpointableHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisExtendedCheckpointable != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisExtendedCheckpointable = null;
		}
	}

	public final ExtendedCheckpointable theExtendedCheckpointable() {
		return thisExtendedCheckpointable;
	}

	protected ExtendedCheckpointable thisExtendedCheckpointable;
	byte[] id;
};
