/**
  * File: PropertiesListenerBaseImpl.java
  * Content: Defines an abstract corba class to implement the PropertiesListener interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the DomainGroupUser CORBA interface.
  **/
public abstract class PropertiesListenerBaseImpl extends PropertiesListenerPOA {

	public PropertiesListenerBaseImpl() throws UserException {
		this(true);
	}

	public PropertiesListenerBaseImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisPropertiesListener == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisPropertiesListener = PropertiesListenerHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisPropertiesListener != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisPropertiesListener = null;
		}
	}

	public final PropertiesListener thePropertiesListener() {
		return thisPropertiesListener;
	}

	protected PropertiesListener thisPropertiesListener;
	byte[] id;
};
