/**
  * File: GroupHandlerFactoryImpl.java
  * Content: Implementation of the GroupHandlerFactory
  * Author: LuisM Pena
  * Date: 3nd December 2000
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.GroupMember;
import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the GroupHandlerFactory
  **/
public abstract class GroupHandlerFactoryBaseImpl extends GroupHandlerFactoryPOA {
	public GroupHandlerFactoryBaseImpl(GroupMember member) throws UserException {
		this.member = member;
		id = ORBcentral.getPOA().activate_object(this);
		thisGroupHandlerFactory = GroupHandlerFactoryHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisGroupHandlerFactory != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisGroupHandlerFactory = null;
		}
	}

	public final GroupHandlerFactory theGroupHandlerFactory() {
		return thisGroupHandlerFactory;
	}

	protected GroupMember member;
	protected GroupHandlerFactory thisGroupHandlerFactory;
	byte[] id;
}
