/**
  * File: MapStringSetBaseImpl.java
  * Content: Implementation of the MapStringSet
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the MapStringSet
  **/
public abstract class MapStringSetBaseImpl extends MapStringSetPOA {
	public MapStringSetBaseImpl() throws UserException {
		id = ORBcentral.getPOA().activate_object(this);
		thisMapStringSet = MapStringSetHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisMapStringSet != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisMapStringSet = null;
		}
	}

	public final MapStringSet theMapStringSet() {
		return thisMapStringSet;
	}

	protected MapStringSet thisMapStringSet;
	byte[] id;
};
