/**
  * File: SetMemberInfoObserverBaseImpl.java
  * Content: Implementation of the SetMemberInfoObserver
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the SetMemberInfoObserver
  **/
public abstract class SetMemberInfoObserverBaseImpl extends SetMemberInfoObserverPOA {
	public SetMemberInfoObserverBaseImpl() throws UserException {
		id = ORBcentral.getPOA().activate_object(this);
		thisSetMemberInfoObserver = SetMemberInfoObserverHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisSetMemberInfoObserver != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisSetMemberInfoObserver = null;
		}
	}

	public final SetMemberInfoObserver theSetMemberInfoObserver() {
		return thisSetMemberInfoObserver;
	}

	protected SetMemberInfoObserver thisSetMemberInfoObserver;
	byte[] id;
};
