/**
  * File: GMSnarrower.java
  * Content: Utility class performing narrow operations for GMS middleware objects
  * Author: LuisM Pena
  * Date: 15th December 2000
  * Version: 0.80.00
  * Last change:
  *
  **/

package sensei.middleware.gms;

/**
  * Utility class performing narrow operations for GMS middleware objects
  **/
public class GMSnarrower {

	public final static org.omg.CORBA.Object toObject(Object object) {
		return object instanceof org.omg.CORBA.Object ? (org.omg.CORBA.Object) object : null;
	}

	public final static GroupHandler toGroupHandler(Object object) {
		GroupHandler ret = null;
		try {
			ret = GroupHandlerHelper.narrow(toObject(object));
		}
		catch (Exception ex) {
			ret = null;
		}
		return ret;
	}

	public final static GroupMember toGroupMember(Object object) {
		GroupMember ret = null;
		try {
			ret = GroupMemberHelper.narrow(toObject(object));
		}
		catch (Exception ex) {
			ret = null;
		}
		return ret;
	}

	public final static SenseiGMSMember toSenseiGMSMember(Object object) {
		SenseiGMSMember ret = null;
		try {
			ret = SenseiGMSMemberHelper.narrow(toObject(object));
		}
		catch (Exception ex) {
			ret = null;
		}
		return ret;
	}

};
