/**
  * File: GroupHandlerFactoryImpl.java
  * Content: Implementation of the GroupHandlerFactory
  * Author: LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last changes:
  *
  **/

package sensei.gmns;

import sensei.gms.ActiveGroupMember;
import sensei.middleware.gmns.GroupHandlerFactoryBaseImpl;
import sensei.middleware.gmns.GroupHandlerFactoryException;
import sensei.middleware.gms.GroupHandler;
import sensei.middleware.gms.GroupMember;

/**
  * Implementation of the GroupHandlerFactory
  **/
public class GroupHandlerFactoryImpl extends GroupHandlerFactoryBaseImpl {
	public GroupHandlerFactoryImpl(GroupMember member) throws Exception {
		super(member);
	}

	/**
	  * Creates a new handler. Returns null if no handle can be created
	  **/
	public GroupHandler create() throws GroupHandlerFactoryException {
		GroupHandler ret = null;
		try {
			ret = new ActiveGroupMember(member).theSenseiGMSMember();
		}
		catch (Exception ex) {
			ret = null;
			throw new GroupHandlerFactoryException(ex.getMessage());
		}
		return ret;
	}
}
