/**
  * File: SendMessagesChannelRequester.java
  * Content: Defines a channel requester to send a message
  * Author: LuisM Pena
  * Date: 6th August 2000
  * Version: 0.97.00
  * Last change:
  *				21th August: renamed from SendMessages into CastMessages
  *
  **/

package sensei.gms;

import java.io.IOException;

import sensei.middleware.gms.Message;
import sensei.middleware.gms.MessageId;
import sensei.middleware.gms.SenseiGMSMember;

//*************************************************************************************//
//**************************** CAST MESSAGES CHANNEL REQUESTER ************************//
//*************************************************************************************//

/**
  * Channel Requester used to cast messages
  **/
class CastMessagesChannelRequester extends ChannelRequester {

	public CastMessagesChannelRequester(int thisMember) {
		Trace.code("CastMessagesChannelRequester.java -> CastMessagesChannelRequester ( int thisMember )");
		this.thisMember = thisMember;
		messages = null;
		messageId = null;
	}

	public void setMessagesToSend(Message[] messages, MessageId messageId) {
		Trace.code("CastMessagesChannelRequester.java -> void setMessagesToSend ( Message [ ] messages , MessageId messageId )");
		this.messages = messages;
		this.messageId = messageId;
	}

	public boolean invokeMember(SenseiGMSMember channelMember) throws IOException{
		Trace.code("CastMessagesChannelRequester.java -> boolean invokeMember ( SenseiGMSMember channel )");
		
		assert messages != null && messageId != null;

		return channelMember.receiveMessages(thisMember, messages, messageId);
	}

	int thisMember;
	Message[] messages;
	MessageId messageId;
}
