/**
  * File: ConfirmMessagesChannelRequester.java
  * Content: Defines a channel requester to confirm a message previously sent
  * Author: LuisM Pena
  * Date: 6th August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import java.io.IOException;

import sensei.middleware.gms.MessageId;
import sensei.middleware.gms.SenseiGMSMember;

//*************************************************************************************//
//**************************** CONFIRM MESSAGES CHANNEL REQUESTER *********************//
//*************************************************************************************//

/**
  * Channel Requester used to confirm a message previously sent
  **/
class ConfirmMessagesChannelRequester extends ChannelRequester {

	public ConfirmMessagesChannelRequester(int thisMember) {
		Trace.code("ConfirmMessagesChannelRequester.java -> ConfirmMessagesChannelRequester ( int thisMember )");
		this.thisMember = thisMember;
		messageId = null;
	}

	public void setMessageIdToConfirm(MessageId messageId) {
		Trace.code("ConfirmMessagesChannelRequester.java -> void setMessageIdToConfirm ( MessageId messageId )");
		this.messageId = messageId;
	}

	public boolean invokeMember(SenseiGMSMember channelMember) throws IOException{
		Trace.code("ConfirmMessagesChannelRequester.java -> boolean invokeMember ( SenseiGMSMember channel )");

		assert messageId != null;

		return channelMember.confirmMessages(thisMember, messageId);
	}

	int thisMember;
	MessageId messageId;
}
