/**
  * File: SendMessagesChannelRequester.java
  * Content: Defines a channel requester to send a message
  * Author: LuisM Pena
  * Date: 21th August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import java.io.IOException;

import sensei.middleware.gms.Message;
import sensei.middleware.gms.MessageId;
import sensei.middleware.gms.SenseiGMSMember;

//*************************************************************************************//
//**************************** SEND MESSAGES CHANNEL REQUESTER ************************//
//*************************************************************************************//

/**
  * Channel Requester used to send a message to some specific member
  **/
class SendMessagesChannelRequester extends ChannelRequester {

	public SendMessagesChannelRequester(int thisMember) {
		Trace.code("SendMessagesChannelRequester.java -> SendMessagesChannelRequester ( int thisMember )");
		this.thisMember = thisMember;
		messages = null;
		messageId = null;
	}

	public void setMessagesToSend(Message[] messages, MessageId messageId) {
		Trace.code("SendMessagesChannelRequester.java -> void setMessagesToSend ( Message [ ] messages , MessageId messageId )");
		this.messages = messages;
		this.messageId = messageId;
	}

	public boolean invokeMember(SenseiGMSMember channelMember) throws IOException{
		Trace.code("SendMessagesChannelRequester.java -> boolean invokeMember ( SenseiGMSMember channel )");

		assert messages != null && messageId != null;

		return channelMember.receivePTPMessages(thisMember, messages, messageId);
	}

	int thisMember;
	Message[] messages;
	MessageId messageId;
}
