/**
  * File: 		BehaviourOnViewChanges.java
  * Content: 	part of the RMI specification of sensei domains
  *           Defines an enumeration for the behaviours under view changes
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

final public class BehaviourOnViewChanges implements java.io.Serializable
{
    private static BehaviourOnViewChanges [] values_ = new BehaviourOnViewChanges[3];
    private int value_;

    public final static int _MembersOnTransferExcludedFromGroup = 0;
    public final static BehaviourOnViewChanges MembersOnTransferExcludedFromGroup = new BehaviourOnViewChanges(_MembersOnTransferExcludedFromGroup);
    public final static int _StatelessMembersDoNotBelongToGroup = 1;
    public final static BehaviourOnViewChanges StatelessMembersDoNotBelongToGroup = new BehaviourOnViewChanges(_StatelessMembersDoNotBelongToGroup);
    public final static int _StatelessMembersBelongToGroup = 2;
    public final static BehaviourOnViewChanges StatelessMembersBelongToGroup = new BehaviourOnViewChanges(_StatelessMembersBelongToGroup);

    protected
    BehaviourOnViewChanges(int value)
    {
        values_[value] = this;
        value_ = value;
    }

    public int
    value()
    {
        return value_;
    }

    public int
    hash()
    {
        return value_;
    }

    protected Object readResolve() throws java.io.ObjectStreamException
    {
      return values_[value_];
    }

    public static BehaviourOnViewChanges
    from_int(int value)
    {
        return values_[value];
    }
}
