/**
  * File: DynamicSubgroupsUserBaseImpl.java
  * Content: Defines an abstract rmi class to implement the DynamicSubgroupsUser interface
  * Author: LuisM Pena
  * Date: 28th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

/**
  * Implementation of the DynamicSubgroupsUser RMI interface.
  **/
public abstract class DynamicSubgroupsUserBaseImpl extends UnicastRemoteObject implements DynamicSubgroupsUser
{

  public DynamicSubgroupsUserBaseImpl() throws RemoteException
  {
    thisDynamicSubgroupsUser=this;
  }

  public DynamicSubgroupsUserBaseImpl(boolean activate) throws RemoteException
  {
    if (!activate)
      deactivate();
  }

  public void activate() throws RemoteException
  {
    if (thisDynamicSubgroupsUser==null)
    {
      thisDynamicSubgroupsUser=this;
      exportObject(this);
    }
  }

  public void deactivate() throws RemoteException
  {
    synchronized (this)
    {
      if (thisDynamicSubgroupsUser!=null)
        unexportObject(thisDynamicSubgroupsUser,true);
      thisDynamicSubgroupsUser=null;
    }
  }

  public final DynamicSubgroupsUser theDynamicSubgroupsUser()
  {
    return thisDynamicSubgroupsUser;
  }

  protected DynamicSubgroupsUser thisDynamicSubgroupsUser;
};

