/**
  * File: 		MemberStateException.java
  * Content: 	part of the RMI specification of sensei domains
  *           Exception thrown after a invalid state on the member
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

import java.rmi.RemoteException;

final public class MemberStateException extends RemoteException
{
    public
    MemberStateException()
    {
        super();
    }

    public
    MemberStateException(MemberStateExceptionReason reason)
    {
      this.reason = reason;
    }

    public
    MemberStateException(String _reason, MemberStateExceptionReason reason)
    {
      super(_reason);
      this.reason = reason;
    }

    public MemberStateExceptionReason reason;
}
