/**
  * File: 		MessageE.java
  * Content: 	part of the RMI specification of sensei domains
  *           Message e is sent when a transfer has finished, containing
  *           the member that has received the state and its properties
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;
/**
 *  Message e is sent when a transfer has finished, containing
 *  the member that has received the state and its properties
 */
public class MessageE extends DomainMessage
{
    public int viewId; //message can only be processed on the right view, depending on the model
    public int member;
    public Property[] props; //properties of the member getting state
};

