/**
  * File: MapStringSetObserverBaseImpl.java
  * Content: Implementation of the MapStringSetObserver
  * Author: LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

/**
  * Implementation of the MapStringSetObserver RMI interface.
  **/
public abstract class MapStringSetObserverBaseImpl extends UnicastRemoteObject
  implements MapStringSetObserver
{

  public MapStringSetObserverBaseImpl() throws RemoteException
  {
    thisMapStringSetObserver=this;
  }

  public MapStringSetObserverBaseImpl(boolean activate) throws RemoteException
  {
    if (!activate)
      deactivate();
  }

  public void activate() throws RemoteException
  {
    if (thisMapStringSetObserver==null)
    {
      thisMapStringSetObserver=this;
      exportObject(this);
    }
  }

  public void deactivate() throws RemoteException
  {
    synchronized (this)
    {
      if (thisMapStringSetObserver!=null)
        unexportObject(thisMapStringSetObserver,true);
      thisMapStringSetObserver=null;
    }
  }

  public final MapStringSetObserver theMapStringSetObserver()
  {
    return thisMapStringSetObserver;
  }

  protected MapStringSetObserver thisMapStringSetObserver;
}
