/**
  * File: SetMemberInfoBaseImpl.java
  * Content: Implementation of the SetMemberInfo
  * Author: LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

/**
  * Implementation of the SetMemberInfo RMI interface.
  **/
public abstract class SetMemberInfoBaseImpl extends UnicastRemoteObject
  implements SetMemberInfo
{

  public SetMemberInfoBaseImpl() throws RemoteException
  {
    thisSetMemberInfo=this;
  }

  public SetMemberInfoBaseImpl(boolean activate) throws RemoteException
  {
    if (!activate)
      deactivate();
  }

  public void activate() throws RemoteException
  {
    if (thisSetMemberInfo==null)
    {
      thisSetMemberInfo=this;
      exportObject(this);
    }
  }

  public void deactivate() throws RemoteException
  {
    synchronized (this)
    {
      if (thisSetMemberInfo!=null)
        unexportObject(thisSetMemberInfo,true);
      thisSetMemberInfo=null;
    }
  }

  public final SetMemberInfo theSetMemberInfo()
  {
    return thisSetMemberInfo;
  }

  protected SetMemberInfo thisSetMemberInfo;
}
