/**
  * File: DebugOutput.java
  * Content: Interface to complement the debug functionality
  * Author: LuisM Pena
  * Date: 19th August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.util;

public interface ErrorHandler {
	/**
	  * Handles a runtime error, probably due to a debug assertion or directly
	  * a error catched in the code.
	  * @return false if the error has not been handled
	  **/
	public boolean handleError(String area, String reason);

	/**
	  * Handles an exception
	  * @return false if the exception has not been handled
	  **/
	public boolean handleException(String area, Exception exception);
}
