/**
  * File: ParameterException.java
  * Content: Exception thrown after an incorrect argument
  * Author: LuisM Pena
  * Date: 21st October 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.util;

/**
  * Exception thrown after an incorrect argument
  **/
public class ParameterException extends Exception {
	public final static String ALREADY_SET = ": is already set";
	public final static String NOT_ALLOWED = ": is not valid";
	public final static String NO_ASSOCIATION = ": not value given";
	public final static String ARGUMENT_NOT_DEFINED = ": argument not defined";
	public final static String PARAMETER_NOT_DEFINED = ": parameter not defined";
	public final static String DEFINITION_NOT_DEFINED = ": value not defined";

	public ParameterException(String arg) {
		super(arg);
	}

	public ParameterException(String arg, String reason) {
		super(arg + reason);
	}

	public ParameterException(int args) {
		super("Wrong number of arguments");
		if (false && args == 0);
	}

	public ParameterException(String reason, int number) {
		super(String.valueOf(number) + reason);
	}
}
