/*
 * Created on Mar 3, 2004
 */
package senseiTests.chat;

import java.io.IOException;

import sensei.gmns.GroupHandlerFactoryImpl;
import sensei.gmns.GroupMembershipNamingServiceFactory;
import sensei.gms.ActiveGroupMember;
import sensei.middleware.gmns.GroupMembershipNamingService;
import sensei.middleware.gms.GroupMember;
import sensei.middleware.gms.SenseiGMSMemberImpl;
import sensei.util.Configuration;
import senseiTests.chat.middleware.MainBase;

/**
 * @author luismi
 */
public class Main extends MainBase {
	
	public Main(String args[]){
		super(args);
	}
	
	public SenseiGMSMemberImpl createGroupMember(GroupMember impl) throws Exception{
		return new ActiveGroupMember(impl);
	}
	
	public boolean joinGMNS(GroupMember impl) throws Exception{
		GroupMembershipNamingService gmns = GroupMembershipNamingServiceFactory.load();
		if (gmns == null)
			System.out.println("No GroupMembershipNamingService found");
		else {
			if (gmns.findAndJoinGroup("ChatMember group", new GroupHandlerFactoryImpl(impl).theGroupHandlerFactory(), "NoName", null) == null)
				System.out.println("Not joined :-(");
			else
				return true;
		}
		return false;
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) throws IOException{
		if (args.length > 0)
			Configuration.getSingleton(args[args.length - 1], null);
		new Main(args);
	}

}
